#include "includeSdl.h"
#include "../../emu/h/types.h"
#include "../../emu/h/emuPalette.h"
#include "../../nes/h/ppu.h"
#include "../../nes/h/nesGeneral.h"

#include "main.h"
#include "video.h"

static Uint32 iStart, iEnd;
static Uint16 sFps;

void FrameDef()
{
	sFps = 0;
	iStart = SDL_GetTicks();
	SDL_Delay(1000 - (SDL_GetTicks() % 1000));
	iStart = SDL_GetTicks();
}

void StartFrame(ui *pitch, void **surface)
{
	if (SDL_MUSTLOCK(screen))
		SDL_LockSurface(screen);

	if (pal16)
	{
		*surface = screen->pixels;
		*pitch = screen->pitch / 2;
	}/*
	else if (pal24)
	{
		*surface = (void*)ddsdBack.lpSurface;
		*pitch = ddsdBack.lPitch;
	}*/
	else if (pal32)
	{
		*surface = screen->pixels;
		*pitch = screen->pitch / 4;
	}
}

void Render()
{
	if (SDL_MUSTLOCK(screen))
		SDL_UnlockSurface(screen);

	SDL_Flip(screen);
}

void EndFrameNTSC()
{
	const char fps = 60;
	char sz[256];

	sFps++;
	iEnd = SDL_GetTicks();

	if ( (sFps == fps) && (s32)(iEnd - iStart) < 1000 )
		SDL_Delay((s32)(1000 - (iEnd % 1000)));

	if ( (s32)(iEnd - iStart) < (s32)((sFps - 0.5) * ((float)1000/fps)) )
		SDL_Delay((s32)((sFps - 0.5) * ((float)1000/fps)) - (s32)(iEnd - iStart));

	iEnd = SDL_GetTicks();
	if ((iEnd - iStart) > 999)
	{
		if (g_badOp != -1)
			sprintf(sz, "%s %d fps - Bad op found", wndName, sFps);
		else
			sprintf(sz, "%s %d fps", wndName, sFps);

		SDL_WM_SetCaption(sz, 0);
		iStart  = SDL_GetTicks();
		iStart -= (iStart % 1000);
		sFps = 0;
	}
}

void EndFramePAL()
{
	const char fps = 50;
	char sz[256];

	sFps++;
	iEnd = SDL_GetTicks();

	if ( (sFps == fps) && (s32)(iEnd - iStart) < 1000 )
		SDL_Delay((s32)(1000 - (iEnd % 1000)));

	if ( (s32)(iEnd - iStart) < (s32)((sFps - 0.5) * ((float)1000/fps)) )
		SDL_Delay((s32)((sFps - 0.5) * ((float)1000/fps)) - (s32)(iEnd - iStart));

	iEnd = SDL_GetTicks();
	if ((iEnd - iStart) > 999)
	{
		sprintf(sz, "%s %d fps", wndName, sFps);
		SDL_WM_SetCaption(sz, 0);
		iStart  = SDL_GetTicks();
		iStart -= (iStart % 1000);
		sFps = 0;
	}
}
